-- Exercise 1
drop table PLSQL101_TEST_1;

CREATE TABLE plsql101_test_1 (
     first_name CHAR(15), 
     last_name  CHAR(20)
     )
;

INSERT INTO plsql101_test_1 VALUES ('Jane', 'Smith');
INSERT INTO plsql101_test_1 VALUES ('Christopher', 'Allen');

SELECT * FROM plsql101_test_1;

DROP TABLE plsql101_test_1;

SELECT * FROM plsql101_test_1;


-- Exercise 2: CHAR() and VARCHAR2() ---------------------------------------------------------
CREATE TABLE plsql101_test_2 ( 
     name   VARCHAR2(20), 
     gender CHAR(1) 
     )
;

INSERT INTO plsql101_test_2 VALUES ('George', 'M');
INSERT INTO plsql101_test_2 VALUES ('Jane', 'F');

SELECT * FROM plsql101_test_2;

DROP TABLE plsql101_test_2;


-- Exercise 3: NUMBER(,) ---------------------------------------------------------
CREATE TABLE plsql101_product ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2)
     )
;

INSERT INTO plsql101_product VALUES ('Product Name 1', 1);
INSERT INTO plsql101_product VALUES ('Product Name 2', 2.5);
INSERT INTO plsql101_product VALUES ('Product Name 3', 50.75);
INSERT INTO plsql101_product VALUES ('Product Name 4', 99.99);
 
SELECT * FROM plsql101_product;

DROP TABLE plsql101_product;


-- Exercise 4: DATE ---------------------------------------------------------
CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2),
     purchase_date DATE
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Product Name 1', 1, '5-NOV-00');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 2', 2.5, '29-JUN-01');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 3', 50.75, '10-DEC-02');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 4', 99.99, '31-AUG-03');

SELECT * FROM plsql101_purchase;



-- Exercise 4b: DESCribe
DESC plsql101_purchase



-- Exercise 5: NOT NULL ---------------------------------------------------------
DROP TABLE plsql101_purchase;

CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25) NOT NULL, 
     product_price NUMBER(4,2)  NOT NULL,
     purchase_date DATE         
     )
;


-- Exercise 6: INSERT NULL VALUES ------------------------------------------------------
INSERT INTO plsql101_purchase VALUES ('Product Name 1', 1, NULL);

SELECT * FROM plsql101_purchase;


INSERT INTO plsql101_purchase VALUES 
     (NULL, 2.5, '29-JUN-01');
INSERT INTO plsql101_purchase VALUES  
     ('Product Name 3', null, '10-DEC-02');
INSERT INTO plsql101_purchase VALUES 
     (NULL, NULL, '31-AUG-03');

SELECT * FROM plsql101_purchase;


INSERT INTO plsql101_purchase (product_name, product_price) 
     VALUES ('Product Name 2', 2.5);
INSERT INTO plsql101_purchase (product_name, product_price) 
     VALUES ('Product Name 3', 50.75);
INSERT INTO plsql101_purchase (product_price, product_name) 
     VALUES (99.99, 'Product Name 4');

SELECT * FROM plsql101_purchase;


-- Exercise 7: INSERTING DATA CONTAINING APOSTROPHES ---------------------------------
INSERT INTO plsql101_purchase VALUES 
     ('Fifth Product's Name', 25, '05-MAY-03');


SET SCAN OFF

INSERT INTO plsql101_purchase VALUES 
     ('Fifth Product''s Name', 25, '05-MAY-03');

SET SCAN ON


SELECT * FROM plsql101_purchase;

-- Exercise 7: SELECT SPECIFIC COLUMNS ------------------------------------------------------
SELECT product_name FROM plsql101_purchase;

SELECT product_name, purchase_date FROM plsql101_purchase;


-- Exercise 7b: Changing column order
SELECT purchase_date, product_price, product_name 
FROM   plsql101_purchase;



-- Exercise 8: MATH OPERATIONS ------------------------------------------------------
SELECT product_name, product_price * 1.15 FROM plsql101_purchase;


DROP TABLE plsql101_purchase;

CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2),
     sales_tax     NUMBER(4,2),
     purchase_date DATE, 
     salesperson   VARCHAR2(3)
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Product Name 1', 1, .08, '5-NOV-00', 'AB');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 2', 2.5, .21, '29-JUN-01', 'CD');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 3', 50.75, 4.19, '10-DEC-02', 'EF');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 4', 99.99, 8.25, '31-AUG-03', 'GH');

SELECT product_name, product_price + sales_tax FROM plsql101_purchase;
SELECT product_name, 100 - product_price FROM plsql101_purchase;
SELECT product_name, sales_tax / product_price FROM plsql101_purchase;


-- Exercise 9: CONCATENATING TEXT ------------------------------------------------------
SELECT product_name || ' was sold by ' || salesperson
FROM   plsql101_purchase;

SELECT product_name || ' was sold by ' || salesperson SOLDBY
FROM   plsql101_purchase;

SELECT product_name || ' was sold by ' || salesperson "Sold By"
FROM   plsql101_purchase;
