-- ========================= BEGINNING OF CHAPTER 4 =========================
/* 
-- Catch-up DDL and DML commands
DROP TABLE plsql101_product;
CREATE TABLE plsql101_product ( 
     product_name     VARCHAR2(25), 
     product_price    NUMBER(4,2),
     quantity_on_hand NUMBER(5,0),
     last_stock_date  DATE
     )
;

INSERT INTO plsql101_product VALUES 
     ('Small Widget', 99, 1, '15-JAN-03');
INSERT INTO plsql101_product VALUES 
     ('Medium Wodget', 75, 1000, '15-JAN-02');
INSERT INTO plsql101_product VALUES 
     ('Chrome Phoobar', 50, 100, '15-JAN-03');
INSERT INTO plsql101_product VALUES 
     ('Round Chrome Snaphoo', 25, 10000, null);

DROP TABLE plsql101_purchase;
CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     salesperson   VARCHAR2(3),
     purchase_date DATE, 
     quantity      NUMBER(4,2)
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Small Widget', 'CA', '14-JUL-03', 1);
INSERT INTO plsql101_purchase VALUES 
     ('Medium Wodget', 'BB', '14-JUL-03', 75);
INSERT INTO plsql101_purchase VALUES 
     ('Chrome Phoobar', 'GA', '14-JUL-03', 2);
INSERT INTO plsql101_purchase VALUES 
     ('Small Widget', 'GA', '15-JUL-03', 8);
INSERT INTO plsql101_purchase VALUES 
     ('Medium Wodget', 'LB', '15-JUL-03', 20);
INSERT INTO plsql101_purchase VALUES 
     ('Round Snaphoo', 'CA', '16-JUL-03', 5);

*/

-- Exercise 20: EDIT
-- Note: the following command purposely contains misspellings in the first two lines
SELECT   product_nmae
FROM     plsql101_produtc
WHERE    quantity_on_hand >= 100
         AND
         last_stock_date IS NOT NULL
ORDER BY product_name;


-- Exercise 21: CHANGE single-line
-- Note: the following command purposely contains a misspelling
SELECT product_nmae FROM plsql101_product;
change/nmae/name
/



-- Exercise 22: CHANGE multi-line
-- Note: the following command purposely contains misspellings 
-- in the first two lines
SELECT   product_nmae
FROM     plsql101_produtc
WHERE    quantity_on_hand >= 100
         AND
         last_stock_date IS NOT NULL
ORDER BY product_name;

1
c/ma/am
2
c/tc/ct
/

-- Possible exercise to add to show other SQL*Plus line-editing commands
l
0 desc PLSQL101_PRODUCT;;
l
9 select distinct PRODUCT_NAME from PLSQL101_PURCHASE;;
l
1 select sysdate from dual;;
8 desc PLSQL101_PURCHASE;;
l
del 1
del 7
l


-- Exercise 23: Copying and Pasting commands
SELECT * FROM plsql101_product;

UPDATE plsql101_product
SET    product_name = 'Large Widget'
WHERE  product_name = 'Small Widget';

update PLSQL101_PRODUCT
set    PRODUCT_NAME = 'Small Widget'
where  PRODUCT_NAME = 'Large Widget';



-- Exercise 24: Setting SQL*Plus environment variables
SET LINESIZE 1000
SET PAGESIZE 9999



-- Exercise 25: Formatting SQL*Plus output
INSERT INTO plsql101_product VALUES (
     'Extra Huge Mega Phoobar +', 
     9.95, 
     1234, 
     '15-JAN-04')
;


-- Aligning decimals
SELECT * FROM plsql101_product;

COLUMN product_price FORMAT 9999.99

SELECT * FROM plsql101_product;


-- Adding a group separator
COLUMN quantity_on_hand FORMAT 99,999

SELECT * FROM plsql101_product;


-- Including a currency symbol
COLUMN product_price FORMAT $99.99

SELECT * FROM plsql101_product;


-- Wrapping text
SELECT * FROM plsql101_product;

COLUMN product_name FORMAT A10 WORD_WRAP

SELECT * FROM plsql101_product;


-- Formatting headings
SELECT * FROM plsql101_product;

COLUMN product_name HEADING 'Product|Name' JUSTIFY CENTER

SELECT * FROM plsql101_product;


-- Applying all formatting types introduced
SELECT * FROM plsql101_product;

COLUMN product_name FORMAT A10 WORD_WRAP HEADING 'Name' JUSTIFY CENTER
COLUMN product_price FORMAT $99.99 HEADING 'Price' JUSTIFY RIGHT
COLUMN quantity_on_hand FORMAT 99,999 HEADING 'On|Hand' JUSTIFY RIGHT
COLUMN last_stock_date HEADING 'Last|Stock|Date' JUSTIFY RIGHT

SELECT * FROM plsql101_product;


-- Disable the column formatting
COLUMN product_name OFF
COLUMN product_price OFF
COLUMN quantity_on_hand OFF
COLUMN last_stock_date OFF

SELECT * FROM plsql101_product;


/*
-- ===============================================================
Another nice use of the above concepts is to create a script that will change
your sql prompt to the name of your database.  This can be very convenient
when working with multiple databases.  This script, SET_UP_PROMPT.SQL, can be
added to your login.sql file so that it is run automatically upon invoking
SQL*Plus.

     set termout off
     set heading off
     set feedback off
     spool set_prompt.sql
     select 'set sqlprompt '||value||'>' from v$parameter where name='db_name';
     spool off
     start set_prompt.sql

The script, SET_PROMPT.SQL, created and run will look like this:

     set sqlprompt V715>

-- ===============================================================
*/


-- Exercise 26: Spooling files
SPOOL c:\plsql101_test.prn
SELECT * FROM plsql101_product;
SELECT * FROM plsql101_purchase;
SPOOL OFF


-- Exercise 27: Creating a script file
/*
EDIT c:\plsql101_test.sql

-- Insert the following commands into the script file
CREATE TABLE plsql101_temp (
     first_name VARCHAR2(15),
     last_name  VARCHAR2(25)
     )
;

INSERT INTO plsql101_temp VALUES ('Joe', 'Smith');
INSERT INTO plsql101_temp VALUES ('Jane', 'Miller');

SELECT * FROM plsql101_temp;

DROP TABLE plsql101_temp;
*/

@c:\plsql101_test


-- Exercise 27: Subsititution variables
edit p:\plsql101_test2.sql

/* Insert the following commands into the script file
SET VERIFY OFF

SELECT product_name, quantity, purchase_date
FROM   plsql101_purchase
WHERE  quantity >= &minimum_quantity_sold
;

SET VERIFY ON
*/

@p:\plsql101_test2



edit p:\plsql101_test3.sql

/* Insert the following commands into the script file
SET VERIFY OFF

SELECT product_name, quantity, purchase_date
FROM   plsql101_purchase
WHERE  purchase_date = '&date_you_want_to_select'
;

SET VERIFY ON
*/

@p:\plsql101_test3


-- ACCEPT command
edit p:\plsql101_test4.sql

/* Insert the following commands into the script file
SET VERIFY OFF
SET ECHO OFF

ACCEPT v_earliest_date PROMPT 'Earliest date you would like to see? (dd-mmm-yy): '
ACCEPT v_latest_date PROMPT 'Thank you. Latest date you would like to see? (dd-mmm-yy): '
SELECT product_name, quantity, purchase_date
FROM   plsql101_purchase
WHERE  purchase_date BETWEEN '&v_earliest_date' AND '&v_latest_date'
ORDER BY product_name, quantity
;

SET VERIFY ON
SET ECHO ON
*/

@p:\plsql101_test4

