-- ========================= BEGINNING OF CHAPTER 5 =========================
/* Catch-up if starting in this chapter without doing previous chapters' exercises
DROP TABLE plsql101_product;
CREATE TABLE plsql101_product ( 
     product_name     VARCHAR2(25), 
     product_price    NUMBER(4,2),
     quantity_on_hand NUMBER(5,0),
     last_stock_date  DATE
     )
;

INSERT INTO plsql101_product VALUES 
     ('Small Widget', 99, 1, '15-JAN-03');
INSERT INTO plsql101_product VALUES 
     ('Medium Wodget', 75, 1000, '15-JAN-02');
INSERT INTO plsql101_product VALUES 
     ('Chrome Phoobar', 50, 100, '15-JAN-03');
INSERT INTO plsql101_product VALUES 
     ('Round Chrome Snaphoo', 25, 10000, null);
INSERT INTO plsql101_product VALUES 
     ('Extra Huge Mega Phoobar +',9.95,1234,'15-JAN-04');

DROP TABLE plsql101_purchase;
CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     salesperson   VARCHAR2(3),
     purchase_date DATE, 
     quantity      NUMBER(4,2)
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Small Widget', 'CA', '14-JUL-03', 1);
INSERT INTO plsql101_purchase VALUES 
     ('Medium Wodget', 'BB', '14-JUL-03', 75);
INSERT INTO plsql101_purchase VALUES 
     ('Chrome Phoobar', 'GA', '14-JUL-03', 2);
INSERT INTO plsql101_purchase VALUES 
     ('Small Widget', 'GA', '15-JUL-03', 8);
INSERT INTO plsql101_purchase VALUES 
     ('Medium Wodget', 'LB', '15-JUL-03', 20);
INSERT INTO plsql101_purchase VALUES 
     ('Round Snaphoo', 'CA', '16-JUL-03', 5);

-- Note: The "Round Snaphoo" records in PRODUCT and PURCHASE are
-- out of sync in terms of product name.  Good opportunity to use this
-- later to enforce the importance of referential integrity.
*/


-- Exercise 27: Sysdate
SELECT SYSDATE FROM DUAL;

INSERT INTO plsql101_purchase VALUES 
     ('Small Widget', 10, sysdate, 'SH');

INSERT INTO plsql101_purchase VALUES 
     ('Medium Wodget', 15, sysdate-14, 'SH');
INSERT INTO plsql101_purchase VALUES 
     ('Round Snaphoo', 25, sysdate-7, 'SH');
INSERT INTO plsql101_purchase VALUES 
     ('Chrome Phoobar', 10, sysdate+7, 'SH');

SELECT * FROM plsql101_purchase 
WHERE  purchase_date BETWEEN (SYSDATE-30) AND SYSDATE;

DELETE FROM plsql101_purchase
WHERE  SALESPERSON = 'SH';


-- Exercise 28: USER
SELECT USER FROM DUAL;



-- Exercise 29: USERENV('TERMINAL')
SELECT USERENV('TERMINAL') FROM DUAL;


-- Exercise 30: ROUND
SELECT product_name, product_price
FROM   plsql101_product;

SELECT product_name, ROUND(product_price, 0)
FROM   plsql101_product;

SELECT ROUND(1234.5678, 4) FROM DUAL;
SELECT ROUND(1234.5678, 3) FROM DUAL;
SELECT ROUND(1234.5678, 2) FROM DUAL;
SELECT ROUND(1234.5678, 1) FROM DUAL;
SELECT ROUND(1234.5678, 0) FROM DUAL;
SELECT ROUND(1234.5678, -1) FROM DUAL;
SELECT ROUND(1234.5678, -2) FROM DUAL;
SELECT ROUND(1234.5678, -3) FROM DUAL;


-- Exercise 31: TRUNC
SELECT TRUNC(1234.5678, 4) FROM DUAL;
SELECT TRUNC(1234.5678, 3) FROM DUAL;
SELECT TRUNC(1234.5678, 2) FROM DUAL;
SELECT TRUNC(1234.5678, 1) FROM DUAL;
SELECT TRUNC(1234.5678, 0) FROM DUAL;
SELECT TRUNC(1234.5678, -1) FROM DUAL;
SELECT TRUNC(1234.5678, -2) FROM DUAL;
SELECT TRUNC(1234.5678, -3) FROM DUAL;


-- Exercise 32: UPPER, LOWER, and INITCAP
SELECT UPPER(product_name) FROM plsql101_product;
SELECT LOWER(product_name) FROM plsql101_product;
SELECT INITCAP(product_name) FROM plsql101_product;

SELECT INITCAP('this TEXT hAd UNpredictABLE caSE') FROM DUAL;


UPDATE plsql101_product
SET    product_name = 'chrome phoobar'
WHERE  product_name = 'Chrome Phoobar';

SELECT * FROM plsql101_product
WHERE  UPPER(product_name) LIKE '%PHOOBAR%';


SELECT INITCAP(product_name), 
       product_price, 
       quantity_on_hand, 
       last_stock_date
FROM   plsql101_product
WHERE  UPPER(product_name) LIKE '%PHOOBAR%';

UPDATE plsql101_product
SET    product_name = 'Chrome Phoobar'
WHERE  product_name = 'chrome phoobar';


-- Exercise 33: LENGTH
SELECT   product_name, LENGTH(product_name) NAME_LENGTH
FROM     plsql101_product
WHERE    LENGTH(product_name) >15
ORDER BY product_name;


-- Exercise 34: SUBSTR
drop table PLSQL101_OLD_ITEM;

CREATE TABLE plsql101_old_item (
     item_id   CHAR(20),
     item_desc CHAR(25)
     )
;

INSERT INTO plsql101_old_item VALUES
     ('LA-101', 'Can, Small');
INSERT INTO plsql101_old_item VALUES
     ('LA-102', 'Can, Large');
INSERT INTO plsql101_old_item VALUES
     ('LA-103', 'Bottle, Small');
INSERT INTO plsql101_old_item VALUES
     ('LA-104', 'Bottle, Large');
INSERT INTO plsql101_old_item VALUES
     ('NY-101', 'Box, Small');
INSERT INTO plsql101_old_item VALUES
     ('NY-102', 'Box, Large');
INSERT INTO plsql101_old_item VALUES
     ('NY-103', 'Shipping Carton, Small');
INSERT INTO plsql101_old_item VALUES
     ('NY-104', 'Shipping Carton, Large');

SELECT SUBSTR(item_id, 1, 2) MFGR_LOCATION,
       SUBSTR(item_id, 4, 3) ITEM_NUMBER,
       item_desc
FROM   plsql101_old_item
;


-- Exercise 35: INSTR
SELECT item_desc, 
       INSTR(item_desc, 
             ',', 
             1
             ) 
FROM   plsql101_old_item;


SELECT item_desc,
       SUBSTR(item_desc, 
              1, 
              INSTR(item_desc, 
                    ',', 
                    1
                    ) -1
              )
FROM   plsql101_old_item;


SELECT item_desc,
       SUBSTR(item_desc, 
              INSTR(item_desc, 
                    ',', 
                    1
                    ) +2,
              99
              )
FROM   plsql101_old_item;


SELECT item_desc,
       SUBSTR(item_desc, 
              1, 
              INSTR(item_desc, 
                    ',', 
                    1
                    ) -1
              ) CATEGORY,
       SUBSTR(item_desc, 
              INSTR(item_desc, 
                    ',', 
                    1
                    ) +2,
              99
              ) ITEM_SIZE
FROM   plsql101_old_item;



-- Exercise 36: LTRIM and RTRIM
SELECT 'Item  ' || 
       item_id ||
       ' is described as a ' ||
       item_desc ||
       '.'  "Item Description Sentence"
FROM   plsql101_old_item;

SELECT 'Item  ' || 
       RTRIM(item_id) ||
       ' is described as a ' ||
       RTRIM(item_desc) ||
       '.'  "Item Description Sentence"
FROM   plsql101_old_item;


/*
-- The following code would be a good basis for a
-- quiz question asking the student to modify the code
-- to solve the space-padding problem of CHAR columns.
-- This code is NOT SHOWN IN THE BOOK.
select 'The Item ID for a ' ||
       substr(ITEM_DESC,
              instr(ITEM_DESC,
                    ',',
                    1
                    ) +2,
              99
              ) ||
       ' ' ||
       substr(ITEM_DESC,
              1,
              instr(ITEM_DESC,
                    ',',
                    1
                    ) -1
              ) ||        
       ' is: ' ||
       ITEM_ID ||
       '.' "Item ID sentence"
from   PLSQL101_OLD_ITEM;

-- Corrected version:
-- This code is NOT SHOWN IN THE BOOK.
select 'The Item ID for a ' ||
       rtrim(substr(ITEM_DESC,
                    instr(ITEM_DESC,
                          ',',
                          1
                          ) +2,
                    99
                    )
             ) ||
       ' ' ||
       substr(ITEM_DESC,
              1,
              instr(ITEM_DESC,
                    ',',
                    1
                    ) -1
              ) ||        
       ' is: ' ||
       rtrim(ITEM_ID) ||
       '.' "Item ID sentence"
from   PLSQL101_OLD_ITEM;

*/



-- Exercise 36: TRUNC(SYSDATE)
INSERT INTO plsql101_product VALUES 
     ('Square Zinculator', 45, 1, SYSDATE);

SELECT * FROM plsql101_product;

-- Note: In the following command, the hard-coded date will need to be 
-- changed to the current day on which this is being demonstrated.
SELECT * FROM plsql101_product
WHERE  last_stock_date = '09-JUL-00';

-- Now do the version that will work
SELECT * FROM plsql101_product
WHERE  TRUNC(last_stock_date) = '09-JUL-00';

DELETE FROM plsql101_product 
WHERE  product_name = 'Square Zinculator';

INSERT INTO plsql101_product VALUES 
     ('Square Zinculator', 45, 1, trunc(sysdate));

-- Note: In the following command, the hard-coded date will need to be 
-- changed to the current day on which this is being demonstrated.
SELECT * FROM plsql101_product
WHERE  last_stock_date = '09-JUL-00';


-- Exercise 37: ADD_MONTHS
SELECT ADD_MONTHS(SYSDATE,1) FROM DUAL;
SELECT ADD_MONTHS(SYSDATE,12) FROM DUAL;

SELECT ADD_MONTHS('28-NOV-00', 1) FROM DUAL;
SELECT ADD_MONTHS('29-NOV-00', 1) FROM DUAL;
SELECT ADD_MONTHS('30-NOV-00', 1) FROM DUAL;
SELECT ADD_MONTHS('31-DEC-00', -1) FROM DUAL;



-- Exercise 38: LAST_DAY
SELECT LAST_DAY(SYSDATE) FROM DUAL;
SELECT LAST_DAY('01-JAN-02') FROM DUAL;
SELECT LAST_DAY('15-JAN-02') FROM DUAL;
SELECT LAST_DAY('31-JAN-02') FROM DUAL;


drop table PLSQL101_PERSON;

CREATE TABLE plsql101_person (
     person_code VARCHAR2(3),
     first_name  VARCHAR2(15),
     last_name   VARCHAR2(20),
     hire_date   DATE
     )
;

INSERT INTO plsql101_person VALUES
     ('CA', 'Charlene', 'Atlas', '01-FEB-02');
INSERT INTO plsql101_person VALUES
     ('GA', 'Gary', 'Anderson', '15-FEB-02');
INSERT INTO plsql101_person VALUES
     ('BB', 'Bobby', 'Barkenhagen', '28-FEB-02');
INSERT INTO plsql101_person VALUES
     ('LB', 'Laren', 'Baxter', '01-MAR-02');

SELECT first_name, 
       last_name,
       hire_date,
       LAST_DAY(hire_date)+1 INSURANCE_START_DATE
FROM   plsql101_person;

SELECT product_name,
       quantity_on_hand,
       last_stock_date,
       LAST_DAY(ADD_MONTHS(last_stock_date, 3))+1 RESTOCK_DATE
FROM   plsql101_product
WHERE  quantity_on_hand <= 100
ORDER BY product_name;



-- Exercise 39: MONTHS_BETWEEN
select months_between(sysdate+100, sysdate) from dual;
select round(months_between(sysdate+100, sysdate),0) from dual;

SELECT product_name,
       last_stock_date,
       MONTHS_BETWEEN(SYSDATE, last_stock_date) STOCK_MONTHS
FROM   plsql101_product;

SELECT product_name,
       last_stock_date,
       ROUND(MONTHS_BETWEEN(SYSDATE, last_stock_date),0) STOCK_MONTHS
FROM   plsql101_product;




-- Exercise 40: TO_CHAR (dates)
SELECT TO_CHAR(SYSDATE, 'MM-DD-YYYY HH24:MI:SS') NOW
FROM DUAL;

select PRODUCT_NAME, 
       PRODUCT_PRICE, 
       QUANTITY_ON_HAND,
       to_char(LAST_STOCK_DATE, 'MON DD, YYYY HH24:MI') LAST_STOCK_DATE
from   PLSQL101_PRODUCT;

SELECT TO_CHAR(SYSDATE, 'MONTH DDTH') 
FROM DUAL;

SELECT TO_CHAR(SYSDATE, 'MONTH DDSP') 
FROM DUAL;

SELECT TO_CHAR(SYSDATE, 'MONTH DDSPTH') 
FROM DUAL;

SELECT INITCAP(RTRIM(TO_CHAR(SYSDATE, 'MONTH'))) ||
       ' ' ||
       TO_CHAR(SYSDATE, 'DDTH') 
FROM DUAL;


select initcap(
            rtrim(
                 to_char(sysdate, 'MONTH')
                 )
            ) ||
       ' ' || 
       initcap(
            to_char(sysdate, 'DDSPTH')
       )
from dual;

SELECT INITCAP(RTRIM(TO_CHAR(SYSDATE, 'MONTH'))) ||
       ' ' ||
       LOWER(TO_CHAR(SYSDATE, 'DDTH')) 
FROM DUAL;



-- Exercise 41: TO_CHAR (numbers)
SELECT * FROM plsql101_product;

SELECT product_name, 
       TO_CHAR(product_price, '$9,999.00') "Price",
       quantity_on_hand,
       last_stock_date
FROM   plsql101_product;

-- The following command creates Figure 5-17
select PRODUCT_NAME, 
       to_char(PRODUCT_PRICE, '$9,999.00') "Price",
       to_char(QUANTITY_ON_HAND, '999,999') "On Hand",
       '  '|| to_char(LAST_STOCK_DATE, 'MON DD, YYYY') "Last Stocked"
from   PLSQL101_PRODUCT;


-- Exercise 42: TO_DATE
SELECT product_name, 
       product_price,
       quantity_on_hand,
       TO_CHAR(last_stock_date, 'MM-DD-YYYY HH24:MI') "Last Stocked"
FROM   plsql101_product;

UPDATE plsql101_product
SET    last_stock_date = TO_DATE('December 31, 2002, 11:30 P.M.',
                                 'Month dd, YYYY, HH:MI P.M.')
WHERE  product_name LIKE '%Zinc%';

SELECT product_name, 
       product_price,
       quantity_on_hand,
       TO_CHAR(last_stock_date, 'MM-DD-YYYY HH24:MI') "Last Stocked"
FROM   plsql101_product;



-- Exercise 43: DECODE
SELECT DECODE(SUBSTR(item_id, 1, 2),
              'LA', 'Western',
              'NY', 'Eastern',
              '* Unknown *'
              ) "Region",
       SUBSTR(item_id, 4,3) "Item ID",
       item_desc
FROM   plsql101_old_item;



-- Exercise 44: NVL
SELECT product_name,
       last_stock_date
FROM   plsql101_product;

SELECT product_name,
       NVL(last_stock_date, '01-JAN-2001') "Last Stocked"
FROM   plsql101_product;


SELECT product_name,
       NVL(last_stock_date, TRUNC(SYSDATE)) "Last Stocked"
FROM   plsql101_product;


-- This will fail, because the datatypes of 
-- the two arguments are different
SELECT product_name,
       NVL(last_stock_date, 'N/A') "Last Stocked"
FROM   plsql101_product;

-- This version accommodates the datatype difference by
-- placing a TO_CHAR function around the LAST_STOCK_DATE
SELECT product_name,
       NVL(TO_CHAR(last_stock_date), 'N/A') "Last Stocked"
FROM   plsql101_product;


-- Exercise 45: USER
select user from dual;


-- Exercise 46: USERENV('TERMINAL')
select userenv('terminal') from dual;


-- Exercise 47: Inserting comments in scripts

SELECT * FROM plsql101_product;
-- This line will be ignored.  Oracle will not try to run it.
SELECT * FROM plsql101_purchase;


/*
This script is designed to show how multiple-line commenting works.
It is used in the PL/SQL 101 book by Oracle Press.
*/

SELECT * FROM plsql101_product; 

SELECT * FROM plsql101_purchase;



-- Exercise 48: SUM
SELECT * FROM plsql101_purchase;
SELECT SUM(quantity) FROM plsql101_purchase;

SELECT COUNT(*) FROM plsql101_purchase;
SELECT COUNT(product_name) FROM plsql101_purchase;
SELECT COUNT(1) FROM plsql101_purchase;



SELECT COUNT(1) FROM plsql101_product;

SELECT COUNT(product_name) FROM plsql101_product;

SELECT COUNT(last_stock_date) FROM plsql101_product;

SELECT COUNT(last_stock_date) / COUNT(product_name) "Populated Records"
FROM plsql101_product;



-- Exercise 49: AVG
SELECT AVG(product_price) FROM plsql101_product;


-- Exercise 50: MIN
SELECT MIN(product_price) FROM plsql101_product;



-- Exercise 51: MAX
SELECT MAX(product_price) FROM plsql101_product;

DESC plsql101_purchase;
SELECT MAX(LENGTH(product_name)) FROM plsql101_purchase;

-- Exercise 52: GROUP BY
SELECT * FROM plsql101_purchase;

SELECT product_name, SUM(quantity) 
FROM   plsql101_purchase
GROUP BY product_name;


SELECT SUBSTR(product_name, 1, 15) "Product", 
       SUM(quantity) "Total Sold",
       AVG(quantity) "Average",
       COUNT(quantity) "Transactions",
       MIN(quantity) "Fewest",
       MAX(quantity) "Most"
FROM   plsql101_purchase
GROUP BY product_name;


-- Exercise 53: HAVING
SELECT SUBSTR(product_name, 1, 15) "Product", 
       SUM(quantity) "Total Sold",
       AVG(quantity) "Average",
       COUNT(quantity) "Transactions",
       MIN(quantity) "Fewest",
       MAX(quantity) "Most"
FROM   plsql101_purchase
GROUP BY product_name
HAVING SUM(quantity) < 5;

SELECT SUBSTR(product_name, 1, 15) "Product", 
       SUM(quantity) "Total Sold",
       AVG(quantity) "Average",
       COUNT(quantity) "Transactions",
       MIN(quantity) "Fewest",
       MAX(quantity) "Most"
FROM   plsql101_purchase
GROUP BY product_name
HAVING SUM(quantity) >= 5;
